package json_views

// |@@| C

import (
	"encoding/json"
	"gardening/src/dat/maes"
	"gardening/src/srv/serializers"
)

type UpdatePlantationJsonView struct {
	PlantationSerializer *serializers.PlantationSerializer
}

func (this *UpdatePlantationJsonView) Json(maeOut *maes.UpdatePlantationMaeOut) ([]byte, error) {
	m := make(map[string]interface{})
	var err error
	if maeOut.Success == false {
		m["messages"] = maeOut.Extra.Messages
		m["form_bag"] = maeOut.Response.FormBag
		return json.Marshal(m)
	}
	m["item"], err = this.plantationToJson(maeOut)
	if err != nil {
		return nil, err
	}
	m["form_bag"], err = this.formBagToJson(maeOut)
	if err != nil {
		return nil, err
	}
	m["form_fields"], err = this.formFieldsToJson(maeOut)
	if err != nil {
		return nil, err
	}
	return json.Marshal(m)
}
func (this *UpdatePlantationJsonView) plantationToJson(maeOut *maes.UpdatePlantationMaeOut) (json.RawMessage, error) {
	return this.PlantationSerializer.OneToJson(maeOut.Response.Plantation)
}
func (this *UpdatePlantationJsonView) formBagToJson(maeOut *maes.UpdatePlantationMaeOut) (json.RawMessage, error) {
	return json.Marshal(maeOut.Response.FormBag)
}
func (this *UpdatePlantationJsonView) formFieldsToJson(maeOut *maes.UpdatePlantationMaeOut) (json.RawMessage, error) {
	return json.Marshal(maeOut.Response.FormFields)
}
